//sketch asciiSwitches as a function and also interrupt handler enterAscii: 
//Reads 8 switches and displays ascii equivalent character on the 16X2 LCD

#include "LiquidCrystal.h"

// initialize the library by providing the number of pins to connect to LCD
LiquidCrystal lcd(8, 9, 4, 5, 6, 7);
int n = 0; //  character position in second line of display
bool enter; //boolean to test recent ENTER button puse


void setup() {
  enter=false;
  lcd.begin(16, 2); //start LCD 16 x 2
  pinMode(2, INPUT_PULLUP); //to be used for interrupt ENTER button
  attachInterrupt (digitalPinToInterrupt(2), enterAscii, FALLING);

  // set analog pin numbers for Arduino Mega
  pinMode(A8, INPUT_PULLUP);// set pull-up on analog pin A8 for LSB of binary input mega pin #88
  pinMode(A9, INPUT_PULLUP);// set pull-up on analog pin A9
  pinMode(A10, INPUT_PULLUP);// set pull-up on analog pin A10
  pinMode(A11, INPUT_PULLUP);// set pull-up on analog pin A11
  pinMode(A12, INPUT_PULLUP);// set pull-up on analog pin A12
  pinMode(A13, INPUT_PULLUP);// set pull-up on analog pin A13
  pinMode(A14, INPUT_PULLUP);// set pull-up on analog pin A14
  pinMode(A15, INPUT_PULLUP);// set pull-up on analog pin A15 for bit 8, MSB of binary input mega pin #82

  pinMode(A7, INPUT_PULLUP);// on off test

}
void loop()
{
  char ascii = 0x00;
  int  Switches = 0;
  lcd.setCursor(0, 0);  // set cursor position to start of first line on the LCD
  lcd.print("My name is  ");

   // Turn off the blinking cursor:blinking cursor experiment
 //lcd.noBlink();
  //delay(3000);
  // Turn on the blinking cursor:
  //lcd.blink();
  
// Turn off the cursor:
//  lcd.noCursor();
  //delay(500);
  // Turn on the cursor:rsor obn or off
 // lcd.cursor();
 // delay(500)
  if (enter) //push button to post a new character
  {
    delay (200); // debounce
    // lcd.print(n);//position of curser for troubleshooting
    int  Switches = readSwitches (Switches);
    ascii = ascii + Switches; //ASCII character for switches value
    lcd.setCursor(n, 1);// set cursor position to n of second line on the LCD
    lcd.print(ascii);
    n = n + 1;
    enter=false;
  }

  delay (500);// wait after posting a new character

}
void enterAscii() //test of interrupt
{ static unsigned long last_interrupt_time = 0;
 unsigned long interrupt_time = millis();
 // If interrupts come faster than 300ms, assume it's a bounce and ignore
 if (interrupt_time - last_interrupt_time > 300)
 {
  enter=true;
 }
 last_interrupt_time = interrupt_time;
 
}

int readSwitches ( int Switches ) // function to return value Switches
{
  //  Switches = 0;
  if (digitalRead(A8) == HIGH)
    Switches += 1;
  if (digitalRead(A9) == HIGH)
    Switches += 2;
  if (digitalRead(A10) == HIGH)
    Switches += 4;
  if (digitalRead(A11) == HIGH)
    Switches += 8;
  if (digitalRead(A12) == HIGH)
    Switches += 16;
  if (digitalRead(A13) == HIGH)
    Switches += 32;
  if (digitalRead(A14) == HIGH)
    Switches += 64;
  if (digitalRead(A15) == HIGH)
    Switches += 128;

  return Switches;
}




